// MainFrm.cpp : CMainFrame NX̎
//

#include "stdafx.h"
#include "MMA_G.h"

#include "MainFrm.h"
#include "MainTreeView.h"
#include "MainListView.h"
#include "GlobalData.h"
#include "Define.h"
#include "RealtimeData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
//	ON_WM_ACTIVATE()
//	ON_COMMAND(ID_APP_EXIT, &CMainFrame::OnAppExit)
	ON_WM_CLOSE()
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_GUIDE, OnUpdateStatusGude)
	ON_MESSAGE(WM_USER_REALTIME_GRAPH, OnUserRealtimeGraph)
	ON_MESSAGE(WM_USER_CLOSE_GRAPH, OnUserCloseGraph)
	ON_MESSAGE(WM_USER_MESSAGE_BOX, OnUserMessageBox)
	ON_MESSAGE(WM_USER_AUTO_CONV, OnUserAutoConv)
	ON_WM_DESTROY()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
//	ID_INDICATOR_GUIDE,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame RXgNV/fXgNV

CMainFrame::CMainFrame()
{
	// TODO: oR[hɒǉĂB
}

CMainFrame::~CMainFrame()
{
	for(int i = 0 ; i< g_iInfoNum; i++){
		if( g_pSensorInfo != NULL ){
			if( g_pSensorInfo[i].idx != -1 ){
				if( g_pSensorInfo[i].sel_dat != NULL ){
					delete [] g_pSensorInfo[i].sel_dat;
				}
				if( g_pSensorInfo[i].dat != NULL ){
					delete [] g_pSensorInfo[i].dat;
				}
				if( g_pSensorInfo[i].dir_x != NULL ){
					delete [] g_pSensorInfo[i].dir_x;
				}
				if( g_pSensorInfo[i].dir_y != NULL ){
					delete [] g_pSensorInfo[i].dir_y;
				}
				if( g_pSensorInfo[i].dir_z != NULL ){
					delete [] g_pSensorInfo[i].dir_z;
				}
				if( g_pSensorInfo[i].category != NULL ){
					delete [] g_pSensorInfo[i].category;
				}
				if( g_pSensorInfo[i].measurement_kind != NULL ){
					delete [] g_pSensorInfo[i].measurement_kind;
				}
			}
			else{
				break;
			}
		}
		else{
			break;
		}
	}

	if( g_pSensorInfo != NULL ){
		delete [] g_pSensorInfo;
	}

	if (g_pSensorInfoMme != NULL)
		delete [] g_pSensorInfoMme;

	if (g_pSensorInfoAsu != NULL)
		delete g_pSensorInfoAsu;
}

// EBhE쐬
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// c[o[쐬	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("c[ o[̍쐬Ɏs܂B\n");
		return -1;      // 쐬ł܂łB
	}

	// Xe[^Xo[쐬
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Xe[^X o[̍쐬Ɏs܂B\n");
		return -1;      // 쐬ł܂łB
	}

	// TODO: c[ o[hbLO\ɂȂꍇ́A 3 s폜ĂB
//	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
//	EnableDocking(CBRS_ALIGN_ANY);
//	DockControlBar(&m_wndToolBar);

	m_oAutoConv.m_hMainWnd = m_hWnd;

	return 0;
}

void CMainFrame::OnUpdateStatusGude(CCmdUI *pCmdUI)
{
	pCmdUI->Enable();
}

// EBhE쐬O
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;

	cs.style &= ~FWS_ADDTOTITLE;

	return TRUE;
}


// CMainFrame ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame bZ[W nh

// NCAg̈쐬
BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext)
{
	// EBhE쐬܂
	if (!m_wndSplitter.CreateStatic(this, 1, 2))
		return FALSE;

	// Xvb^쐬
	if (!m_wndSplitter.CreateView(0, 0, RUNTIME_CLASS(CMainTreeView), CSize(350, 0), pContext) ||
		!m_wndSplitter.CreateView(0, 1, RUNTIME_CLASS(CMainListView), CSize(0, 0), pContext))
	{
		m_wndSplitter.DestroyWindow();
		return FALSE;
	}

	return TRUE;
}


void CMainFrame::OnClose()
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B

#ifndef _DEBUG
	if( AfxMessageBox("MMAn^pVXe\tgEFAI܂H",MB_ICONQUESTION|MB_YESNO) == IDYES )
#endif
		CFrameWnd::OnClose();
}


LRESULT CMainFrame::OnUserRealtimeGraph(WPARAM wParam, LPARAM lParam)
{
	g_RealtimeData.UpdateGraphWindow();

	return 0;
}

LRESULT CMainFrame::OnUserCloseGraph(WPARAM wParam, LPARAM lParam)
{
	g_RealtimeData.CloseGraphWindow((HWND)wParam);

	return 0;
}

LRESULT CMainFrame::OnUserMessageBox(WPARAM wParam, LPARAM lParam)
{
	return AfxMessageBox((LPCTSTR)wParam, (UINT)lParam);
}

LRESULT CMainFrame::OnUserAutoConv(WPARAM wParam, LPARAM lParam)
{
	m_oAutoConv.ExecAutoConvert((CMaiFile *)wParam, (CString *)lParam);

	return 0;
}

void CMainFrame::OnDestroy()
{
	CGraphFrame::CloseAll();

	CFrameWnd::OnDestroy();
}
